const os = require('os');

const MAVEN_ARCHETYPE_VERSION = '1.6.0';

const constants = {
    IS_WIN: (os.platform() === 'win32'),

    MAVEN_ARCHETYPE_VERSION,

    OPTION_JAVA: 'java',
    OPTION_HANA: 'hana',
    OPTION_MTA: 'mta',
    OPTION_PIPELINE: 'pipeline',

    OPTION_JAVA_PACKAGE: 'java:package',
    OPTION_JAVA_MVN: 'java:mvn',

    // node enum
    PROJECT_TYPE: Object.freeze({ nodejs: 1, java: 2, unknown: 3 }),

    REGEX_JAVA_PACKAGE: /^[a-zA-Z]\w*(\.[a-zA-Z]\w*)*$/g,

    URLS: Object.freeze({
        PIPELINE_HELP: 'https://github.com/SAP/cloud-s4-sdk-pipeline',
        SAMPLES: 'https://github.com/SAP-samples/cloud-cap-samples',
        CAPIRE: 'https://cap.cloud.sap/docs/get-started',
        MAVEN_ARCHETYPE_HELP: `https://jarcasting.com/archetypes/com.sap.cds/cds-services-archetype/${MAVEN_ARCHETYPE_VERSION}/`
    })
}

module.exports = constants;
